package poly;


/*
 * the stack contains a stack of Targets, all of them are locked, but the topmost;
 * it's the creator's responsibility to create the code, restoring the value from 
 * the stack to ensure it is eventually empty
 */


public class Stack extends Rc{
	public Target stack[];
	public int stk[];
	public int sp=0;
	public int stk_sz=0;

	public Stack(String Name, int Stksz) throws PolyException{
		super(Name, 0, 0);

		stack=new Target[Stksz];	// this array keeps Targets
		stk=new int[Stksz];		// this array keeps values
		stk_sz=Stksz;
	}

	public boolean can_write(){
		return (sp<stk_sz);
	}

	public int read(Target what) throws PolyException{
		if (sp<=0){
			throw new PolyException("stack underflow");
		}
		sp--;
		if (sp>0){
			stack[sp-1].stopped--;	// allow the previous Target to execute now
		}
		return value=stk[sp];
	}

	public int write(Target what, int V) throws PolyException{
		if (sp>=stk_sz){
			throw new PolyException("stack overflow");
		}

		int v=0;
		if (sp>0){
			stack[sp-1].stopped++; // so now the Target, which was the topmost, should be disabled, so it would not pop a foreign value
			v=stk[sp-1];
		}
		stack[sp]=what;
		stk[sp]=V;
		value=V;
		sp++;

		return v;
	}
}