/*
 * puny base class to allow return results of heuristics analisys and
 * curing in a common format

 * so, its descendants may contain additional information, which will be passed
 * to other heuristics: say, for curing module, beginning and length of a
 * piece to be placed at a specified offset (copy live flesh from a virus 
 * body); or, say, an execution tree for a piece of code to analyse by some
 * other heuristics.
 */

package utils.av;

public class Result{
	public final static int NOCHANGES = -1; // may be flagged by hueristics when no further clarification was done.
					// (supresses superfluous messages).
					// it is not adviced to do so only for the case a file is healthy.
	public final static int HEALTHY = 0;	// even if "healthy", it does not mean anything, if the consult string is valid
					// Av outputs "OK" only if it is a final verdict. otherwise it will simply output verdict string.
	public final static int SUSPICIOUS = 1;// means simply suspicion. thouh, further investigations may tell more.
	public final static int DETECTED = 2;	// sure detection. just to tell Av to output "detected" string. further heuristics might love to reset this to some other value, if they are not sure about healing, so it won't output "detected" twice
	public final static int UNRECOVERABLE = 3; // unrecoverable. should be destroyed, if it is a final diagnosis.
	public final static int HEALED = 4;	// file was restored to a healthy condition successfully.


	public String verdict;
		// verdict. returns Diagnostic string: presumably name of 
		// a virus or some additional information.
		// may be null or empty.

	public String consult;
		// if is null, do nothing. otherwise it contains
		// a name of ZemskijFershal descendant who is to be
		// passed the results of heuristics process (possibly cure)
		// no one checks for empty strings.

	public int diagnosis;
		// diagnosis.
		// it is not considered a final diagnosis, unless consult 
		// string is null or empty, in which case the Av will store
		// the file byte array into a file.

	public byte [] file;
		// patient.
		// it is allowed to change it.
		// it will be written back as is only in the case diagnosis is
		// "healed" and is final.
		// (some heuristics may want to PKLITE it back, if it had been
		// unpacked due to healing course).

	public boolean save;
		// shows if this file was modified due to healing process 
	// (_was_ ever infected and now is not; needs save or obliteration)

	public Result prev;
		// this is to keep record of _all_ prescriptions and test results

	public Result(String verd, String cons, int diag, byte [] fil, boolean needs_save, Result previous){
		verdict = verd;
		consult = cons;
		diagnosis = diag;
		file = fil;
		save = needs_save;
		prev = previous;
	}
}
